<template>
  <a ref="badge"
    v-if="show_badge"
    type="button"
    class="journal-eligibility-badge badge bg-secondary "
    :class="color_class"
    data-bs-toggle="#tooltip"
    data-bs-placement="top">
    {{ $t('extension.badge_text_' + color) }}
  </a>
</template>
<script>
import { Tooltip } from 'bootstrap'
import helper from '../helper'

export default {
  name: 'JournalEligibilityBadge',
  props: {
    journal: {
      type: Object,
      required: true
    }
  },
  mixins: [helper],
  mounted () {
    /* eslint-disable no-new */
    if (this.show_badge) {
      new Tooltip(this.$refs.badge, {
        title: () => this.$t('extension.badge_tooltip_' + this.color)
      })
    }
  },
  computed: {
    show_badge () {
      return this.$store.state.extension.is_set && (this.journal.green_badge ||
                                                    this.journal.yellow_badge ||
                                                    this.journal.red_badge ||
                                                    this.journal.blue_badge)
    },
    color () {
      if (this.journal.green_badge) {
        return 'green'
      } else if (this.journal.yellow_badge) {
        return 'yellow'
      } else if (this.journal.blue_badge) {
        return 'blue'
      } else {
        return 'red'
      }
    },
    color_class () {
      if (this.color === 'green') {
        return 'bg-success'
      } else if (this.color === 'yellow') {
        return 'bg-warning'
      } else if (this.color === 'blue') {
        return 'bg-info'
      } else {
        return 'bg-danger'
      }
    }
  }
}
</script>
<style scoped>
.journal-eligibility-badge:hover {
  color: white;
}
.journal-eligibility-badge {
  font-size: 8pt !important;
  display: inline-block;
  vertical-align: middle;
  z-index: 1;
  position: relative
}
</style>
